#!/usr/bin/make -f 

#mkdir qiime2-moving-pictures-tutorial
#cd qiime2-moving-pictures-tutorial

all:	intro inputdata demux dada2 featuretable diversity

intro:
	echo "I: adopted from https://docs.qiime2.org/2021.4/tutorials/moving-pictures/"

inputdata: sample-metadata.tsv emp-single-end-sequences/barcodes.fastq.gz emp-single-end-sequences/sequences.fastq.gz

sample-metadata.tsv:
	wget \
	  -O "sample-metadata.tsv" \
	  "https://data.qiime2.org/2021.4/tutorials/moving-pictures/sample_metadata.tsv"

emp-single-end-sequences/barcodes.fastq.gz:
	mkdir -p emp-single-end-sequences
	wget \
	  -O "emp-single-end-sequences/barcodes.fastq.gz" \
	  "https://data.qiime2.org/2021.4/tutorials/moving-pictures/emp-single-end-sequences/barcodes.fastq.gz"

emp-single-end-sequences/sequences.fastq.gz:
	mkdir -p emp-single-end-sequences
	wget \
	  -O "emp-single-end-sequences/sequences.fastq.gz" \
	  "https://data.qiime2.org/2021.4/tutorials/moving-pictures/emp-single-end-sequences/sequences.fastq.gz"

	qiime tools import \
	  --type EMPSingleEndSequences \
	  --input-path emp-single-end-sequences \
	  --output-path emp-single-end-sequences.qza

	qiime tools peek emp-single-end-sequences.qza

demux: demux.qza
demux.qza: emp-single-end-sequences.qza
	qiime demux emp-single \
	  --i-seqs emp-single-end-sequences.qza \
	  --m-barcodes-file sample-metadata.tsv \
	  --m-barcodes-column barcode-sequence \
	  --o-per-sample-sequences demux.qza \
	  --o-error-correction-details demux-details.qza

	qiime demux summarize \
	  --i-data demux.qza \
	  --o-visualization demux.qzv

denoise: dada2
dada2:	table-dada2.qza
table-dada2.qza: demux.qza
	qiime dada2 denoise-single \
	  --i-demultiplexed-seqs demux.qza \
	  --p-trim-left 0 \
	  --p-trunc-len 120 \
	  --o-representative-sequences rep-seqs-dada2.qza \
	  --o-table table-dada2.qza \
	  --o-denoising-stats stats-dada2.qza

	ln -f rep-seqs-dada2.qza rep-seqs.qza
	ln -f table-dada2.qza table.qza
	
	qiime metadata tabulate \
	  --m-input-file stats-dada2.qza \
	  --o-visualization stats-dada2.qzv

featuretable: rep-seqs.qza
rep-seqs.qza: 
	qiime feature-table summarize \
	  --i-table table.qza \
	  --o-visualization table.qzv \
	  --m-sample-metadata-file sample-metadata.tsv
	qiime feature-table tabulate-seqs \
	  --i-data rep-seqs.qza \
	  --o-visualization rep-seqs.qzv

phylogeny: rooted-tree.qza
rooted-tree.qza aligned-rep-seqs.qza: rep-seqs.qza
	qiime phylogeny align-to-tree-mafft-fasttree \
	  --i-sequences rep-seqs.qza \
	  --o-alignment aligned-rep-seqs.qza \
	  --o-masked-alignment masked-aligned-rep-seqs.qza \
	  --o-tree unrooted-tree.qza \
	  --o-rooted-tree rooted-tree.qza

diversity: core-metrics-results/faith_pd_vector.qza
core-metrics-results/faith_pd_vector.qza core-metrics-results/evenness_vector.qza core-metrics-results/unweighted_unifrac_distance_matrix.qza core-metrics-results/unweighted-unifrac-subject-group-significance.qzv: rooted-tree.qza
	qiime diversity core-metrics-phylogenetic \
	  --i-phylogeny rooted-tree.qza \
	  --i-table table.qza \
	  --p-sampling-depth 1103 \
	  --m-metadata-file sample-metadata.tsv \
	  --output-dir core-metrics-results

	qiime diversity alpha-group-significance \
	  --i-alpha-diversity core-metrics-results/faith_pd_vector.qza \
	  --m-metadata-file sample-metadata.tsv \
	  --o-visualization core-metrics-results/faith-pd-group-significance.qzv

	qiime diversity alpha-group-significance \
	  --i-alpha-diversity core-metrics-results/evenness_vector.qza \
	  --m-metadata-file sample-metadata.tsv \
	  --o-visualization core-metrics-results/evenness-group-significance.qzv

	qiime diversity beta-group-significance \
	  --i-distance-matrix core-metrics-results/unweighted_unifrac_distance_matrix.qza \
	  --m-metadata-file sample-metadata.tsv \
	  --m-metadata-column body-site \
	  --o-visualization core-metrics-results/unweighted-unifrac-body-site-significance.qzv \
	  --p-pairwise

	qiime diversity beta-group-significance \
	  --i-distance-matrix core-metrics-results/unweighted_unifrac_distance_matrix.qza \
	  --m-metadata-file sample-metadata.tsv \
	  --m-metadata-column subject \
	  --o-visualization core-metrics-results/unweighted-unifrac-subject-group-significance.qzv \
	  --p-pairwise

	qiime emperor plot \
	  --i-pcoa core-metrics-results/unweighted_unifrac_pcoa_results.qza \
	  --m-metadata-file sample-metadata.tsv \
	  --p-custom-axes days-since-experiment-start \
	  --o-visualization core-metrics-results/unweighted-unifrac-emperor-days-since-experiment-start.qzv

	qiime emperor plot \
	  --i-pcoa core-metrics-results/bray_curtis_pcoa_results.qza \
	  --m-metadata-file sample-metadata.tsv \
	  --p-custom-axes days-since-experiment-start \
	  --o-visualization core-metrics-results/bray-curtis-emperor-days-since-experiment-start.qzv

	qiime diversity alpha-rarefaction \
	  --i-table table.qza \
	  --i-phylogeny rooted-tree.qza \
	  --p-max-depth 4000 \
	  --m-metadata-file sample-metadata.tsv \
	  --o-visualization alpha-rarefaction.qzv



featureclassification:

	echo "E: Does not work because of version differences of classifier"

	wget \
	  -O "gg-13-8-99-515-806-nb-classifier.qza" \
	  "https://data.qiime2.org/2021.4/common/gg-13-8-99-515-806-nb-classifier.qza"

	qiime feature-classifier classify-sklearn \
	  --i-classifier gg-13-8-99-515-806-nb-classifier.qza \
	  --i-reads rep-seqs.qza \
	  --o-classification taxonomy.qza

	qiime metadata tabulate \
	  --m-input-file taxonomy.qza \
	  --o-visualization taxonomy.qzv

	qiime taxa barplot \
	  --i-table table.qza \
	  --i-taxonomy taxonomy.qza \
	  --m-metadata-file sample-metadata.tsv \
	  --o-visualization taxa-bar-plots.qzv

	qiime feature-table filter-samples \
	  --i-table table.qza \
	  --m-metadata-file sample-metadata.tsv \
	  --p-where "[body-site]='gut'" \
	  --o-filtered-table gut-table.qza

	qiime composition add-pseudocount \
	  --i-table gut-table.qza \
	  --o-composition-table comp-gut-table.qza

	qiime composition ancom \
	  --i-table comp-gut-table.qza \
	  --m-metadata-file sample-metadata.tsv \
	  --m-metadata-column subject \
	  --o-visualization ancom-subject.qzv

	qiime taxa collapse \
	  --i-table gut-table.qza \
	  --i-taxonomy taxonomy.qza \
	  --p-level 6 \
	  --o-collapsed-table gut-table-l6.qza

	qiime composition add-pseudocount \
	  --i-table gut-table-l6.qza \
	  --o-composition-table comp-gut-table-l6.qza

	qiime composition ancom \
	  --i-table comp-gut-table-l6.qza \
	  --m-metadata-file sample-metadata.tsv \
	  --m-metadata-column subject \
	  --o-visualization l6-ancom-subject.qzv

